/*
 * loader.h
 *
 * Copyright 2007-2008 Red Hat, Inc.  All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef BDEVID_LOADER_H
#define BDEVID_LOADER_H 1

struct bdevid;
struct bdevid_module;

/* the API a loader uses: */
extern struct bdevid *bdevid_new(char *env);
extern void bdevid_destroy(struct bdevid *);

extern int bdevid_path_set(struct bdevid *, char *path);
extern char *bdevid_path_get(struct bdevid *);

extern int bdevid_module_load_file_maybe(struct bdevid *b, char *file,
                                         char *name);
extern int bdevid_module_load_file(struct bdevid *b, char *file);
extern int bdevid_module_load(struct bdevid *, char *name);
extern int bdevid_module_unload(struct bdevid *, char *name);

/* XXX need module iter ? */

extern int bdevid_module_load_all(struct bdevid *);
extern int bdevid_module_unload_all(struct bdevid *);

#endif /* BDEVID_LOADER_H */

/*
 * vim:ts=8:sts=4:sw=4:et
 */
