/*
 * hotplug.h -- hotplug loading/hotplug event handling
 *
 * Copyright 2006-2008 Red Hat, Inc.  All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author(s): Peter Jones <pjones@redhat.com>
 */

#ifndef NASH_HOTPLUG_H
#define NASH_HOTPLUG_H 1

extern int nashHotplugInit(nashContext *);
extern void nashHotplugNewRoot(nashContext *);
extern void nashHotplugNotifyExit(nashContext *);
extern void nashHotplugKill(nashContext *);

typedef int (*nashFileFetcher_t)(char *inpath, int outfd);
typedef void (*nashDelayFunction_t)(nashContext *, int usec);

extern void nashSetDelayParent(nashContext *, nashDelayFunction_t);
extern void nashSetFileFetcher(nashContext *, nashFileFetcher_t);
extern nashFileFetcher_t nashGetFileFetcher(nashContext *);
extern int nashSetFirmwarePath(nashContext *, char *);
extern char *nashGetFirmwarePath(nashContext *);

#endif /* NASH_HOTPLUG_H */

/*
 * vim:ts=8:sw=4:sts=4:et
 */
