/*
 * log.h -- logging functions for nash
 *
 * Copyright 2006-2008 Red Hat, Inc.  All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author(s): Peter Jones <pjones@redhat.com>
 */

#ifndef NASH_LOG_H
#define NASH_LOG_H 1

#ifdef _GNU_SOURCE
#define _GNU_SOURCE_DEFINED
#else
#define _GNU_SOURCE 1
#endif

#include <stdarg.h>

#include "lib.h"

typedef enum {
    NASH_NOTICE,
    NASH_WARNING,
    NASH_ERROR,
    NASH_DEBUG,
} nash_log_level;

typedef int (*nashLogger_t)(nashContext *, const nash_log_level,
    const char *, va_list)
    __attribute__((format(printf, 3, 0)));

extern void nashSetLogger(nashContext *, nashLogger_t);
extern nashLogger_t nashGetLogger(nashContext *);

extern int nashLoggerV(nashContext *, const nash_log_level level,
    const char *format, va_list ap)
    __attribute__((format(printf, 3, 0)));
extern int nashLogger(nashContext *, const nash_log_level level,
    const char *format, ...)
    __attribute__((format(printf, 3, 4)));

#ifndef _GNU_SOURCE_DEFINED
#undef _GNU_SOURCE
#else
#undef _GNU_SOURCE_DEFINED
#endif

#endif /* NASH_LOG_H */
/*
 * vim:ts=8:sw=4:sts=4:et
 */
